=begin
#Lob

#The Lob API is organized around REST. Our API is designed to have predictable, resource-oriented URLs and uses HTTP response codes to indicate any API errors. <p> Looking for our [previous documentation](https://lob.github.io/legacy-docs/)? 

The version of the OpenAPI document: 1.3.0
Contact: lob-openapi@lob.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.2.1

=end

require 'cgi'

module Lob
  class BuckslipsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # create
    # Creates a new buckslip given information
    # @param buckslip_editable [BuckslipEditable] 
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :front An optional file upload as either a byte array or file type. 
    # @return [Buckslip]
    def create(buckslip_editable, opts = {})
      data, _status_code, _headers = buckslip_create_with_http_info(buckslip_editable, opts)
      data
    end

    # create
    # Creates a new buckslip given information
    # @param buckslip_editable [BuckslipEditable] 
    # @param [Hash] opts the optional parameters
    # @option opts [Object] :front An optional file upload as either a byte array or file type. 
    # @return [Array<(Buckslip, Integer, Hash)>] Buckslip data, response status code and response headers
    def buckslip_create_with_http_info(buckslip_editable, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BuckslipsApi.buckslip_create ...'
      end
      # verify the required parameter 'buckslip_editable' is set
      if @api_client.config.client_side_validation && buckslip_editable.nil?
        fail ArgumentError, "Missing the required parameter 'buckslip_editable' when calling BuckslipsApi.buckslip_create"
      end
      # resource path
      local_var_path = '/buckslips'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'front'] = opts[:'front'] if !opts[:'front'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(buckslip_editable)

      # return_type
      return_type = opts[:debug_return_type] || 'Buckslip'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"BuckslipsApi.buckslip_create",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BuckslipsApi#buckslip_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # delete
    # Delete an existing buckslip. You need only supply the unique identifier that was returned upon buckslip creation.
    # @param buckslip_id [String] id of the buckslip
    # @param [Hash] opts the optional parameters
    # @return [BuckslipDeletion]
    def delete(buckslip_id, opts = {})
      data, _status_code, _headers = buckslip_delete_with_http_info(buckslip_id, opts)
      data
    end

    # delete
    # Delete an existing buckslip. You need only supply the unique identifier that was returned upon buckslip creation.
    # @param buckslip_id [String] id of the buckslip
    # @param [Hash] opts the optional parameters
    # @return [Array<(BuckslipDeletion, Integer, Hash)>] BuckslipDeletion data, response status code and response headers
    def buckslip_delete_with_http_info(buckslip_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BuckslipsApi.buckslip_delete ...'
      end
      # verify the required parameter 'buckslip_id' is set
      if @api_client.config.client_side_validation && buckslip_id.nil?
        fail ArgumentError, "Missing the required parameter 'buckslip_id' when calling BuckslipsApi.buckslip_delete"
      end
      pattern = Regexp.new(/^bck_[a-zA-Z0-9]+$/)
      if @api_client.config.client_side_validation && buckslip_id !~ pattern
        fail ArgumentError, "invalid value for 'buckslip_id' when calling BuckslipsApi.buckslip_delete, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/buckslips/{buckslip_id}'.sub('{' + 'buckslip_id' + '}', CGI.escape(buckslip_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'BuckslipDeletion'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"BuckslipsApi.buckslip_delete",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BuckslipsApi#buckslip_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # get
    # Retrieves the details of an existing buckslip. You need only supply the unique customer identifier that was returned upon buckslip creation.
    # @param buckslip_id [String] id of the buckslip
    # @param [Hash] opts the optional parameters
    # @return [Buckslip]
    def get(buckslip_id, opts = {})
      data, _status_code, _headers = buckslip_retrieve_with_http_info(buckslip_id, opts)
      data
    end

    # get
    # Retrieves the details of an existing buckslip. You need only supply the unique customer identifier that was returned upon buckslip creation.
    # @param buckslip_id [String] id of the buckslip
    # @param [Hash] opts the optional parameters
    # @return [Array<(Buckslip, Integer, Hash)>] Buckslip data, response status code and response headers
    def buckslip_retrieve_with_http_info(buckslip_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BuckslipsApi.buckslip_retrieve ...'
      end
      # verify the required parameter 'buckslip_id' is set
      if @api_client.config.client_side_validation && buckslip_id.nil?
        fail ArgumentError, "Missing the required parameter 'buckslip_id' when calling BuckslipsApi.buckslip_retrieve"
      end
      pattern = Regexp.new(/^bck_[a-zA-Z0-9]+$/)
      if @api_client.config.client_side_validation && buckslip_id !~ pattern
        fail ArgumentError, "invalid value for 'buckslip_id' when calling BuckslipsApi.buckslip_retrieve, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/buckslips/{buckslip_id}'.sub('{' + 'buckslip_id' + '}', CGI.escape(buckslip_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Buckslip'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"BuckslipsApi.buckslip_retrieve",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BuckslipsApi#buckslip_retrieve\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # update
    # Update the details of an existing buckslip. You need only supply the unique identifier that was returned upon buckslip creation.
    # @param buckslip_id [String] id of the buckslip
    # @param buckslip_updatable [BuckslipUpdatable] 
    # @param [Hash] opts the optional parameters
    # @return [Buckslip]
    def update(buckslip_id, buckslip_updatable, opts = {})
      data, _status_code, _headers = buckslip_update_with_http_info(buckslip_id, buckslip_updatable, opts)
      data
    end

    # update
    # Update the details of an existing buckslip. You need only supply the unique identifier that was returned upon buckslip creation.
    # @param buckslip_id [String] id of the buckslip
    # @param buckslip_updatable [BuckslipUpdatable] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Buckslip, Integer, Hash)>] Buckslip data, response status code and response headers
    def buckslip_update_with_http_info(buckslip_id, buckslip_updatable, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BuckslipsApi.buckslip_update ...'
      end
      # verify the required parameter 'buckslip_id' is set
      if @api_client.config.client_side_validation && buckslip_id.nil?
        fail ArgumentError, "Missing the required parameter 'buckslip_id' when calling BuckslipsApi.buckslip_update"
      end
      pattern = Regexp.new(/^bck_[a-zA-Z0-9]+$/)
      if @api_client.config.client_side_validation && buckslip_id !~ pattern
        fail ArgumentError, "invalid value for 'buckslip_id' when calling BuckslipsApi.buckslip_update, must conform to the pattern #{pattern}."
      end

      # verify the required parameter 'buckslip_updatable' is set
      if @api_client.config.client_side_validation && buckslip_updatable.nil?
        fail ArgumentError, "Missing the required parameter 'buckslip_updatable' when calling BuckslipsApi.buckslip_update"
      end
      # resource path
      local_var_path = '/buckslips/{buckslip_id}'.sub('{' + 'buckslip_id' + '}', CGI.escape(buckslip_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(buckslip_updatable)

      # return_type
      return_type = opts[:debug_return_type] || 'Buckslip'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"BuckslipsApi.buckslip_update",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BuckslipsApi#buckslip_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List
    # Returns a list of your buckslips. The buckslips are returned sorted by creation date, with the most recently created buckslips appearing first.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit How many results to return. (default to 10)
    # @option opts [String] :before A reference to a list entry used for paginating to the previous set of entries. This field is pre-populated in the &#x60;previous_url&#x60; field in the return response. 
    # @option opts [String] :after A reference to a list entry used for paginating to the next set of entries. This field is pre-populated in the &#x60;next_url&#x60; field in the return response. 
    # @option opts [Array<String>] :include Request that the response include the total count by specifying &#x60;include[]&#x3D;total_count&#x60;. 
    # @return [BuckslipsList]
    def List(opts = {})
      data, _status_code, _headers = buckslips_list_with_http_info(opts)
      data
    end

    # List
    # Returns a list of your buckslips. The buckslips are returned sorted by creation date, with the most recently created buckslips appearing first.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit How many results to return. (default to 10)
    # @option opts [String] :before A reference to a list entry used for paginating to the previous set of entries. This field is pre-populated in the &#x60;previous_url&#x60; field in the return response. 
    # @option opts [String] :after A reference to a list entry used for paginating to the next set of entries. This field is pre-populated in the &#x60;next_url&#x60; field in the return response. 
    # @option opts [Array<String>] :include Request that the response include the total count by specifying &#x60;include[]&#x3D;total_count&#x60;. 
    # @return [Array<(BuckslipsList, Integer, Hash)>] BuckslipsList data, response status code and response headers
    def buckslips_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BuckslipsApi.buckslips_list ...'
      end
      if @api_client.config.client_side_validation && !opts[:'limit'].nil? && opts[:'limit'] > 100
        fail ArgumentError, 'invalid value for "opts[:"limit"]" when calling BuckslipsApi.buckslips_list, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'limit'].nil? && opts[:'limit'] < 1
        fail ArgumentError, 'invalid value for "opts[:"limit"]" when calling BuckslipsApi.buckslips_list, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = '/buckslips'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'before'] = opts[:'before'] if !opts[:'before'].nil?
      query_params[:'after'] = opts[:'after'] if !opts[:'after'].nil?
      query_params[:'include'] = @api_client.build_collection_param(opts[:'include'], :multi) if !opts[:'include'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'BuckslipsList'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"BuckslipsApi.buckslips_list",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BuckslipsApi#buckslips_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
