=begin
#Lob

#The Lob API is organized around REST. Our API is designed to have predictable, resource-oriented URLs and uses HTTP response codes to indicate any API errors. <p> Looking for our [previous documentation](https://lob.github.io/legacy-docs/)? 

The version of the OpenAPI document: 1.3.0
Contact: lob-openapi@lob.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.2.1

=end

require 'cgi'

module Lob
  class CreativesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # create
    # Creates a new creative with the provided properties
    # @param creative_writable [CreativeWritable] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :x_lang_output * &#x60;native&#x60; - Translate response to the native language of the country in the request * &#x60;match&#x60; - match the response to the language in the request  Default response is in English. 
    # @return [CreativeResponse]
    def create(creative_writable, opts = {})
      data, _status_code, _headers = creative_create_with_http_info(creative_writable, opts)
      data
    end

    # create
    # Creates a new creative with the provided properties
    # @param creative_writable [CreativeWritable] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :x_lang_output * &#x60;native&#x60; - Translate response to the native language of the country in the request * &#x60;match&#x60; - match the response to the language in the request  Default response is in English. 
    # @return [Array<(CreativeResponse, Integer, Hash)>] CreativeResponse data, response status code and response headers
    def creative_create_with_http_info(creative_writable, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CreativesApi.creative_create ...'
      end
      # verify the required parameter 'creative_writable' is set
      if @api_client.config.client_side_validation && creative_writable.nil?
        fail ArgumentError, "Missing the required parameter 'creative_writable' when calling CreativesApi.creative_create"
      end
      allowable_values = ["native", "match"]
      if @api_client.config.client_side_validation && opts[:'x_lang_output'] && !allowable_values.include?(opts[:'x_lang_output'])
        fail ArgumentError, "invalid value for \"x_lang_output\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/creatives'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end
      header_params[:'x-lang-output'] = opts[:'x_lang_output'] if !opts[:'x_lang_output'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(creative_writable)

      # return_type
      return_type = opts[:debug_return_type] || 'CreativeResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"CreativesApi.creative_create",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CreativesApi#creative_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # get
    # Retrieves the details of an existing creative. You need only supply the unique creative identifier that was returned upon creative creation.
    # @param crv_id [String] id of the creative
    # @param [Hash] opts the optional parameters
    # @return [CreativeResponse]
    def get(crv_id, opts = {})
      data, _status_code, _headers = creative_retrieve_with_http_info(crv_id, opts)
      data
    end

    # get
    # Retrieves the details of an existing creative. You need only supply the unique creative identifier that was returned upon creative creation.
    # @param crv_id [String] id of the creative
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreativeResponse, Integer, Hash)>] CreativeResponse data, response status code and response headers
    def creative_retrieve_with_http_info(crv_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CreativesApi.creative_retrieve ...'
      end
      # verify the required parameter 'crv_id' is set
      if @api_client.config.client_side_validation && crv_id.nil?
        fail ArgumentError, "Missing the required parameter 'crv_id' when calling CreativesApi.creative_retrieve"
      end
      pattern = Regexp.new(/^crv_[a-zA-Z0-9]+$/)
      if @api_client.config.client_side_validation && crv_id !~ pattern
        fail ArgumentError, "invalid value for 'crv_id' when calling CreativesApi.creative_retrieve, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/creatives/{crv_id}'.sub('{' + 'crv_id' + '}', CGI.escape(crv_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'CreativeResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"CreativesApi.creative_retrieve",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CreativesApi#creative_retrieve\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # update
    # Update the details of an existing creative. You need only supply the unique identifier that was returned upon creative creation.
    # @param crv_id [String] id of the creative
    # @param creative_patch [CreativePatch] 
    # @param [Hash] opts the optional parameters
    # @return [CreativeResponse]
    def update(crv_id, creative_patch, opts = {})
      data, _status_code, _headers = creative_update_with_http_info(crv_id, creative_patch, opts)
      data
    end

    # update
    # Update the details of an existing creative. You need only supply the unique identifier that was returned upon creative creation.
    # @param crv_id [String] id of the creative
    # @param creative_patch [CreativePatch] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreativeResponse, Integer, Hash)>] CreativeResponse data, response status code and response headers
    def creative_update_with_http_info(crv_id, creative_patch, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CreativesApi.creative_update ...'
      end
      # verify the required parameter 'crv_id' is set
      if @api_client.config.client_side_validation && crv_id.nil?
        fail ArgumentError, "Missing the required parameter 'crv_id' when calling CreativesApi.creative_update"
      end
      pattern = Regexp.new(/^crv_[a-zA-Z0-9]+$/)
      if @api_client.config.client_side_validation && crv_id !~ pattern
        fail ArgumentError, "invalid value for 'crv_id' when calling CreativesApi.creative_update, must conform to the pattern #{pattern}."
      end

      # verify the required parameter 'creative_patch' is set
      if @api_client.config.client_side_validation && creative_patch.nil?
        fail ArgumentError, "Missing the required parameter 'creative_patch' when calling CreativesApi.creative_update"
      end
      # resource path
      local_var_path = '/creatives/{crv_id}'.sub('{' + 'crv_id' + '}', CGI.escape(crv_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(creative_patch)

      # return_type
      return_type = opts[:debug_return_type] || 'CreativeResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"CreativesApi.creative_update",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CreativesApi#creative_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
