=begin
#Lob

#The Lob API is organized around REST. Our API is designed to have predictable, resource-oriented URLs and uses HTTP response codes to indicate any API errors. <p> Looking for our [previous documentation](https://lob.github.io/legacy-docs/)? 

The version of the OpenAPI document: 1.3.0
Contact: lob-openapi@lob.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.2.1

=end

require 'cgi'

module Lob
  class IdentityValidationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # validate
    # Validates whether a given name is associated with an address.
    # @param multi_line_address [MultiLineAddress] 
    # @param [Hash] opts the optional parameters
    # @return [IdentityValidation]
    def validate(multi_line_address, opts = {})
      data, _status_code, _headers = identity_validation_with_http_info(multi_line_address, opts)
      data
    end

    # validate
    # Validates whether a given name is associated with an address.
    # @param multi_line_address [MultiLineAddress] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(IdentityValidation, Integer, Hash)>] IdentityValidation data, response status code and response headers
    def identity_validation_with_http_info(multi_line_address, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: IdentityValidationApi.identity_validation ...'
      end
      # verify the required parameter 'multi_line_address' is set
      if @api_client.config.client_side_validation && multi_line_address.nil?
        fail ArgumentError, "Missing the required parameter 'multi_line_address' when calling IdentityValidationApi.identity_validation"
      end
      # resource path
      local_var_path = '/identity_validation'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      content_type = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])
      if !content_type.nil?
          header_params['Content-Type'] = content_type
      end

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(multi_line_address)

      # return_type
      return_type = opts[:debug_return_type] || 'IdentityValidation'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['basicAuth']

      new_options = opts.merge(
        :operation => :"IdentityValidationApi.identity_validation",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: IdentityValidationApi#identity_validation\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
