=begin
#Lob

#The Lob API is organized around REST. Our API is designed to have predictable, resource-oriented URLs and uses HTTP response codes to indicate any API errors. <p> Looking for our [previous documentation](https://lob.github.io/legacy-docs/)? 

The version of the OpenAPI document: 1.3.0
Contact: lob-openapi@lob.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.2.1

=end

require 'date'
require 'time'

module Lob
  class Card
    # Unique identifier prefixed with `card_`.
    attr_accessor :id

    # The signed link for the card.
    attr_accessor :url

    # True if the cards should be auto-reordered.
    attr_accessor :auto_reorder

    # The number of cards to be reordered. Only present when auto_reorder is True.
    attr_accessor :reorder_quantity

    # The raw URL of the card.
    attr_accessor :raw_url

    # The original URL of the front template.
    attr_accessor :front_original_url

    # The original URL of the back template.
    attr_accessor :back_original_url

    attr_accessor :thumbnails

    # The available quantity of cards.
    attr_accessor :available_quantity

    # The pending quantity of cards.
    attr_accessor :pending_quantity

    attr_accessor :status

    # The orientation of the card.
    attr_accessor :orientation

    # The threshold amount of the card
    attr_accessor :threshold_amount

    # A timestamp in ISO 8601 format of the date the resource was created.
    attr_accessor :date_created

    # A timestamp in ISO 8601 format of the date the resource was last modified.
    attr_accessor :date_modified

    # Only returned if the resource has been successfully deleted.
    attr_accessor :deleted

    # object
    attr_accessor :object

    # Description of the card.
    attr_accessor :description

    # The size of the card
    attr_accessor :size

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'url' => :'url',
        :'auto_reorder' => :'auto_reorder',
        :'reorder_quantity' => :'reorder_quantity',
        :'raw_url' => :'raw_url',
        :'front_original_url' => :'front_original_url',
        :'back_original_url' => :'back_original_url',
        :'thumbnails' => :'thumbnails',
        :'available_quantity' => :'available_quantity',
        :'pending_quantity' => :'pending_quantity',
        :'status' => :'status',
        :'orientation' => :'orientation',
        :'threshold_amount' => :'threshold_amount',
        :'date_created' => :'date_created',
        :'date_modified' => :'date_modified',
        :'deleted' => :'deleted',
        :'object' => :'object',
        :'description' => :'description',
        :'size' => :'size'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'String',
        :'url' => :'String',
        :'auto_reorder' => :'Boolean',
        :'reorder_quantity' => :'Integer',
        :'raw_url' => :'String',
        :'front_original_url' => :'String',
        :'back_original_url' => :'String',
        :'thumbnails' => :'Array<Thumbnail>',
        :'available_quantity' => :'Integer',
        :'pending_quantity' => :'Integer',
        :'status' => :'String',
        :'orientation' => :'String',
        :'threshold_amount' => :'Integer',
        :'date_created' => :'Time',
        :'date_modified' => :'Time',
        :'deleted' => :'Boolean',
        :'object' => :'String',
        :'description' => :'String',
        :'size' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'reorder_quantity',
        :'description',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Lob::Card` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Lob::Card`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.key?(:'auto_reorder')
        self.auto_reorder = attributes[:'auto_reorder']
      else
        self.auto_reorder = false
      end

      if attributes.key?(:'reorder_quantity')
        self.reorder_quantity = attributes[:'reorder_quantity']
      end

      if attributes.key?(:'raw_url')
        self.raw_url = attributes[:'raw_url']
      end

      if attributes.key?(:'front_original_url')
        self.front_original_url = attributes[:'front_original_url']
      end

      if attributes.key?(:'back_original_url')
        self.back_original_url = attributes[:'back_original_url']
      end

      if attributes.key?(:'thumbnails')
        if (value = attributes[:'thumbnails']).is_a?(Array)
          self.thumbnails = value
        end
      end

      if attributes.key?(:'available_quantity')
        self.available_quantity = attributes[:'available_quantity']
      else
        self.available_quantity = 0
      end

      if attributes.key?(:'pending_quantity')
        self.pending_quantity = attributes[:'pending_quantity']
      else
        self.pending_quantity = 0
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'orientation')
        self.orientation = attributes[:'orientation']
      else
        self.orientation = 'horizontal'
      end

      if attributes.key?(:'threshold_amount')
        self.threshold_amount = attributes[:'threshold_amount']
      else
        self.threshold_amount = 0
      end

      if attributes.key?(:'date_created')
        self.date_created = attributes[:'date_created']
      end

      if attributes.key?(:'date_modified')
        self.date_modified = attributes[:'date_modified']
      end

      if attributes.key?(:'deleted')
        self.deleted = attributes[:'deleted']
      end

      if attributes.key?(:'object')
        self.object = attributes[:'object']
      else
        self.object = 'card'
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'size')
        self.size = attributes[:'size']
      else
        self.size = '2.125x3.375'
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      pattern = Regexp.new(/^card_[a-zA-Z0-9]+$/)
      if @id !~ pattern
        invalid_properties.push("invalid value for \"id\", must conform to the pattern #{pattern}.")
      end

      if @url.nil?
        invalid_properties.push('invalid value for "url", url cannot be nil.')
      end

      if @url.to_s.length > 2083
        invalid_properties.push('invalid value for "url", the character length must be smaller than or equal to 2083.')
      end

      if @url.to_s.length < 1
        invalid_properties.push('invalid value for "url", the character length must be great than or equal to 1.')
      end

      if @auto_reorder.nil?
        invalid_properties.push('invalid value for "auto_reorder", auto_reorder cannot be nil.')
      end

      if !@raw_url.nil? && @raw_url.to_s.length > 2083
        invalid_properties.push('invalid value for "raw_url", the character length must be smaller than or equal to 2083.')
      end

      if !@raw_url.nil? && @raw_url.to_s.length < 1
        invalid_properties.push('invalid value for "raw_url", the character length must be great than or equal to 1.')
      end

      if !@front_original_url.nil? && @front_original_url.to_s.length > 2083
        invalid_properties.push('invalid value for "front_original_url", the character length must be smaller than or equal to 2083.')
      end

      if !@front_original_url.nil? && @front_original_url.to_s.length < 1
        invalid_properties.push('invalid value for "front_original_url", the character length must be great than or equal to 1.')
      end

      if !@back_original_url.nil? && @back_original_url.to_s.length > 2083
        invalid_properties.push('invalid value for "back_original_url", the character length must be smaller than or equal to 2083.')
      end

      if !@back_original_url.nil? && @back_original_url.to_s.length < 1
        invalid_properties.push('invalid value for "back_original_url", the character length must be great than or equal to 1.')
      end

      if @thumbnails.nil?
        invalid_properties.push('invalid value for "thumbnails", thumbnails cannot be nil.')
      end

      if @available_quantity.nil?
        invalid_properties.push('invalid value for "available_quantity", available_quantity cannot be nil.')
      end

      if @pending_quantity.nil?
        invalid_properties.push('invalid value for "pending_quantity", pending_quantity cannot be nil.')
      end

      if @date_created.nil?
        invalid_properties.push('invalid value for "date_created", date_created cannot be nil.')
      end

      if @date_modified.nil?
        invalid_properties.push('invalid value for "date_modified", date_modified cannot be nil.')
      end

      if @object.nil?
        invalid_properties.push('invalid value for "object", object cannot be nil.')
      end

      if !@description.nil? && @description.to_s.length > 255
        invalid_properties.push('invalid value for "description", the character length must be smaller than or equal to 255.')
      end

      if @size.nil?
        invalid_properties.push('invalid value for "size", size cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @id.nil?
      return false if @id !~ Regexp.new(/^card_[a-zA-Z0-9]+$/)
      return false if @url.nil?
      return false if @url.to_s.length > 2083
      return false if @url.to_s.length < 1
      return false if @auto_reorder.nil?
      return false if !@raw_url.nil? && @raw_url.to_s.length > 2083
      return false if !@raw_url.nil? && @raw_url.to_s.length < 1
      return false if !@front_original_url.nil? && @front_original_url.to_s.length > 2083
      return false if !@front_original_url.nil? && @front_original_url.to_s.length < 1
      return false if !@back_original_url.nil? && @back_original_url.to_s.length > 2083
      return false if !@back_original_url.nil? && @back_original_url.to_s.length < 1
      return false if @thumbnails.nil?
      return false if @available_quantity.nil?
      return false if @pending_quantity.nil?
      status_validator = EnumAttributeValidator.new('String', ["processed", "rendered"])
      return false unless status_validator.valid?(@status)
      orientation_validator = EnumAttributeValidator.new('String', ["horizontal", "vertical"])
      return false unless orientation_validator.valid?(@orientation)
      return false if @date_created.nil?
      return false if @date_modified.nil?
      return false if @object.nil?
      object_validator = EnumAttributeValidator.new('String', ["card"])
      return false unless object_validator.valid?(@object)
      return false if !@description.nil? && @description.to_s.length > 255
      return false if @size.nil?
      size_validator = EnumAttributeValidator.new('String', ["3.375x2.125", "2.125x3.375"])
      return false unless size_validator.valid?(@size)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] id Value to be assigned
    def id=(id)
      if id.nil?
        fail ArgumentError, 'id cannot be nil'
      end

      pattern = Regexp.new(/^card_[a-zA-Z0-9]+$/)
      if id !~ pattern
        fail ArgumentError, "invalid value for \"id\", must conform to the pattern #{pattern}."
      end

      @id = id
    end

    # Custom attribute writer method with validation
    # @param [Object] url Value to be assigned
    def url=(url)
      if url.nil?
        fail ArgumentError, 'url cannot be nil'
      end

      if url.to_s.length > 2083
        fail ArgumentError, 'invalid value for "url", the character length must be smaller than or equal to 2083.'
      end

      if url.to_s.length < 1
        fail ArgumentError, 'invalid value for "url", the character length must be great than or equal to 1.'
      end

      @url = url
    end

    # Custom attribute writer method with validation
    # @param [Object] raw_url Value to be assigned
    def raw_url=(raw_url)
      if !raw_url.nil? && raw_url.to_s.length > 2083
        fail ArgumentError, 'invalid value for "raw_url", the character length must be smaller than or equal to 2083.'
      end

      if !raw_url.nil? && raw_url.to_s.length < 1
        fail ArgumentError, 'invalid value for "raw_url", the character length must be great than or equal to 1.'
      end

      @raw_url = raw_url
    end

    # Custom attribute writer method with validation
    # @param [Object] front_original_url Value to be assigned
    def front_original_url=(front_original_url)
      if !front_original_url.nil? && front_original_url.to_s.length > 2083
        fail ArgumentError, 'invalid value for "front_original_url", the character length must be smaller than or equal to 2083.'
      end

      if !front_original_url.nil? && front_original_url.to_s.length < 1
        fail ArgumentError, 'invalid value for "front_original_url", the character length must be great than or equal to 1.'
      end

      @front_original_url = front_original_url
    end

    # Custom attribute writer method with validation
    # @param [Object] back_original_url Value to be assigned
    def back_original_url=(back_original_url)
      if !back_original_url.nil? && back_original_url.to_s.length > 2083
        fail ArgumentError, 'invalid value for "back_original_url", the character length must be smaller than or equal to 2083.'
      end

      if !back_original_url.nil? && back_original_url.to_s.length < 1
        fail ArgumentError, 'invalid value for "back_original_url", the character length must be great than or equal to 1.'
      end

      @back_original_url = back_original_url
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ["processed", "rendered"])
      unless validator.valid?(status)
        fail ArgumentError, "invalid value for \"status\", must be one of #{validator.allowable_values}."
      end
      @status = status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] orientation Object to be assigned
    def orientation=(orientation)
      validator = EnumAttributeValidator.new('String', ["horizontal", "vertical"])
      unless validator.valid?(orientation)
        fail ArgumentError, "invalid value for \"orientation\", must be one of #{validator.allowable_values}."
      end
      @orientation = orientation
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] object Object to be assigned
    def object=(object)
      validator = EnumAttributeValidator.new('String', ["card"])
      unless validator.valid?(object)
        fail ArgumentError, "invalid value for \"object\", must be one of #{validator.allowable_values}."
      end
      @object = object
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length > 255
        fail ArgumentError, 'invalid value for "description", the character length must be smaller than or equal to 255.'
      end

      @description = description
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] size Object to be assigned
    def size=(size)
      validator = EnumAttributeValidator.new('String', ["3.375x2.125", "2.125x3.375"])
      unless validator.valid?(size)
        fail ArgumentError, "invalid value for \"size\", must be one of #{validator.allowable_values}."
      end
      @size = size
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          url == o.url &&
          auto_reorder == o.auto_reorder &&
          reorder_quantity == o.reorder_quantity &&
          raw_url == o.raw_url &&
          front_original_url == o.front_original_url &&
          back_original_url == o.back_original_url &&
          thumbnails == o.thumbnails &&
          available_quantity == o.available_quantity &&
          pending_quantity == o.pending_quantity &&
          status == o.status &&
          orientation == o.orientation &&
          threshold_amount == o.threshold_amount &&
          date_created == o.date_created &&
          date_modified == o.date_modified &&
          deleted == o.deleted &&
          object == o.object &&
          description == o.description &&
          size == o.size
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [id, url, auto_reorder, reorder_quantity, raw_url, front_original_url, back_original_url, thumbnails, available_quantity, pending_quantity, status, orientation, threshold_amount, date_created, date_modified, deleted, object, description, size].hash
    end


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil) # // guardrails-disable-line
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) }) # // guardrails-disable-line
          end
        elsif !attributes[self.class.attribute_map[key]].nil? && type.kind_of?(Array)
          for base_type in type do
            res = _deserialize(base_type, attributes[self.class.attribute_map[key]])
            if !res.nil?
              self.send("#{key}=", res) # // guardrails-disable-line
              break
            end
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]])) # // guardrails-disable-line
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Lob.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr) # // guardrails-disable-line
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
